package com.mudu.controller;

import com.mudu.base.domain.AjaxResult;
import com.mudu.entity.*;
import com.mudu.entity.dto.request.ACheckQuatzRequest;
import com.mudu.entity.dto.request.ACheckQuatzZichaRequest;
import com.mudu.service.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import static com.mudu.base.domain.AjaxResult.success;

/**
 * @author dong
 * @since 2024/3/12 16:37
 */
@RestController
@RequestMapping("pharmaceuticals/aCheck")
@Api(tags = "新增")
@Transactional(rollbackFor = Exception.class)
public class AcheckTaskController {

    /**
     * 服务对象
     */
    @Resource
    private ASafeXcrwService aSafeXcrwService;

    /**
     * 服务对象
     */
    @Resource
    private ASafeXcrwjcxService aSafeXcrwjcxService;

    @Resource
    private ASafeXcrwjcxzgxxService aSafeXcrwjcxzgxxService;

    @Resource
    private ASafeYhzgxxService aSafeYhzgxxService;


    @Resource
    private ASafeZcrwService aSafeZcrwService;


    @Resource
    private ASafeZcrwjlService aSafeZcrwjlService;

    /**
     * 新增创建时间为昨天且处于审批通过的工单数据
     *
     * @param list
     * @Param qymc 企业名称
     */
    @PostMapping("/insert")
    @ApiOperation(value = "新增创建时间为昨天且处于审批通过的工单数据")
    public AjaxResult selectAll(@RequestBody List<ACheckQuatzRequest> list) {
        for (ACheckQuatzRequest a : list) {
            String xcrwuuid = UUID.randomUUID().toString().replace("-", "").toLowerCase();
            String xcrwjcxUuid = UUID.randomUUID().toString().replace("-", "").toLowerCase();
            String xcrwjcxzgxxUuid = UUID.randomUUID().toString().replace("-", "").toLowerCase();
            String xcrwwzUuid = UUID.randomUUID().toString().replace("-", "").toLowerCase();
            String yhzgxxUuid = UUID.randomUUID().toString().replace("-", "").toLowerCase();

            //获取企业编号
            String enterPriseId = a.getEnterpriseID();
            //获取人员编号
            String rybh = a.getRybh();
            /**
             *  新增巡查信息表 a_safe_xcrw
             */
            ASafeXcrw aSafeXcrw = new ASafeXcrw();
            //信息编号
            aSafeXcrw.setXxbh(xcrwuuid);
            //企业编号
            aSafeXcrw.setQybh(enterPriseId);
            //任务类型
            aSafeXcrw.setRwlx("WGXC");
            //巡查项
            aSafeXcrw.setXcx(list.size());
            //完成项
            aSafeXcrw.setWcx(list.size());
            //发现隐患数
            aSafeXcrw.setFxyhs(list.size());
            //检查时间
            if (a.getReportDateTime() != null) {
                aSafeXcrw.setJcsj(a.getReportDateTime());
            } else {
                aSafeXcrw.setJcsj(null);
            }
            //完成状态
            aSafeXcrw.setWczt(1);
            //入库人员
            aSafeXcrw.setRkry(rybh);
            //入库时间
            aSafeXcrw.setRksj(new Date());
            //更新时间
            aSafeXcrw.setGxsj(new Date());
            //更新人员
            aSafeXcrw.setGxry(rybh);
            //记录状态
            aSafeXcrw.setJlzt(1);
            //新增
            aSafeXcrwService.save(aSafeXcrw);
            /**
             * 巡查任务检查项记录 a_safe_xcrwjcx
             */
            ASafeXcrwjcx aSafeXcrwjcx = new ASafeXcrwjcx();
            //信息编号
            aSafeXcrwjcx.setXxbh(xcrwjcxUuid);
            //企业编号
            aSafeXcrwjcx.setQybh(enterPriseId);
            //任务编号对应a_safe_xcrw的信息编号
            aSafeXcrwjcx.setRwbh(xcrwuuid);
            //企业风险点编号 对应a_safe_fxd的信息编号 todo
            if (a.getCheckId() != null) {
                aSafeXcrwjcx.setQyfxdbh(a.getCheckId());
            } else {
                aSafeXcrwjcx.setQyfxdbh("测试");
            }
            //周期编号 todo
            aSafeXcrwjcx.setZqbh("测试");
            //完成状态
            aSafeXcrwjcx.setWczt(1);
            //检查项结果
            aSafeXcrwjcx.setJcxjg(String.valueOf(1));
            //隐患描述
            aSafeXcrwjcx.setYhms(a.getDescription());
            //检查时间
            if (a.getReportDateTime() != null) {
                aSafeXcrwjcx.setJcsj(a.getReportDateTime());
            } else {
                aSafeXcrwjcx.setJcsj(null);
            }
            //整改时间
            if (a.getReportDateTime() != null) {
                aSafeXcrwjcx.setZgsj(a.getReportDateTime());
            } else {
                aSafeXcrwjcx.setZgsj(null);
            }
            //整改期限
            aSafeXcrwjcx.setZgqx(a.getNeedFinalDateTime());
            //整改状态
            aSafeXcrwjcx.setZgzt(1);
            //整改逾期
            Date currentTime = new Date(); // 获取当前时间
            if (currentTime.after(a.getNeedFinalDateTime())) {
                // 超过截止时间，
                aSafeXcrwjcx.setZgyq(1);
            } else {
                // 未超过截止时间，
                aSafeXcrwjcx.setZgyq(0);
            }
            //位置编号 TODO

            //巡查位置编号 TODO

            //巡查风险点编号 TODO

            //任务类型
            aSafeXcrwjcx.setRwlx(3);
            //入库人员
            aSafeXcrwjcx.setRkry(rybh);
            //入库时间
            aSafeXcrwjcx.setRksj(new Date());
            //更新人员
            aSafeXcrwjcx.setGxry(rybh);
            //更新时间
            aSafeXcrwjcx.setGxsj(new Date());
            //记录状态
            aSafeXcrwjcx.setJlzt(1);
            aSafeXcrwjcxService.save(aSafeXcrwjcx);

            /**
             * 巡查任务隐患整改/隐患复查 a_safe_xcrwjcxzgxx
             */
            ASafeXcrwjcxzgxx aSafeXcrwjcxzgxx = new ASafeXcrwjcxzgxx();
            //信息编号
            aSafeXcrwjcxzgxx.setXxbh(xcrwjcxzgxxUuid);
            //任务编号对应a_safe_xcrw的信息编号
            aSafeXcrwjcx.setRwbh(xcrwuuid);
            //巡查检查项编号 a_safe_xcrwjcx的XXBH
            aSafeXcrwjcxzgxx.setXcjcxbh(xcrwjcxUuid);
            //描述 todo
            aSafeXcrwjcxzgxx.setMs("测试");
            //时间
            aSafeXcrwjcxzgxx.setSj(a.getFinalDateTime());
            //类型
            aSafeXcrwjcxzgxx.setSjlx("ZG");
            //是否合格
            aSafeXcrwjcxzgxx.setSfhg(1);
            //到期日期
            aSafeXcrwjcxzgxx.setDqrq(a.getNeedFinalDateTime());
            //入库人员
            aSafeXcrwjcxzgxx.setRkry(rybh);
            //入库时间
            aSafeXcrwjcxzgxx.setRksj(new Date());
            //更新人员
            aSafeXcrwjcxzgxx.setGxry(rybh);
            //更新时间
            aSafeXcrwjcxzgxx.setGxsj(new Date());
            //记录状态
            aSafeXcrwjcxzgxx.setJlzt(1);
            aSafeXcrwjcxzgxxService.save(aSafeXcrwjcxzgxx);
            /**
             * 巡查任务位置 a_safe_xcrwwz
             */
            //xxbh


            /**
             * 巡查风险点位置隐患 a_safe_yhzgxx
             */
            ASafeYhzgxx aSafeYhzgxx = new ASafeYhzgxx();
            //信息编号
            aSafeYhzgxx.setXxbh(yhzgxxUuid);
            //任务编号
            aSafeYhzgxx.setRwbh(xcrwuuid);
            //位置编号 todo
            aSafeYhzgxx.setWzbh(null);
            //企业编号
            aSafeYhzgxx.setQybh(enterPriseId);
            //周期编号
            aSafeYhzgxx.setZqbh(null);
            //企业风险点编号 对应a_safe_fxd的信息编号 todo
            if (a.getCheckId() != null) {
                aSafeYhzgxx.setQyfxdbh(a.getCheckId());
            } else {
                aSafeYhzgxx.setQyfxdbh("测试");
            }
            //隐患来源
            aSafeYhzgxx.setYhly("1");
            //检查时间
            if (a.getReportDateTime() != null) {
                aSafeYhzgxx.setJcsj(a.getReportDateTime());
            } else {
                aSafeYhzgxx.setJcsj(null);
            }
            //整改期限
            aSafeYhzgxx.setZgqx(a.getNeedFinalDateTime());
            //不合格检查项a_safe_xcrwjcx中JCXJG=1的数量
            aSafeYhzgxx.setBhgjcx(list.size());
            //整改状态
            aSafeYhzgxx.setZgzt(1);
            //巡查位置编号a_safe_xcrwwz的XXBH TODO

            //入库人员
            aSafeYhzgxx.setRkry(rybh);
            //入库时间
            aSafeYhzgxx.setRksj(new Date());
            //更新人员
            aSafeYhzgxx.setGxry(rybh);
            //更新时间
            aSafeYhzgxx.setGxsj(new Date());
            //记录状态
            aSafeYhzgxx.setJlzt(1);
            aSafeYhzgxxService.save(aSafeYhzgxx);
            /**
             * 附件表a_safe_rwfj
             */
            //todo 少实体类

        }


        return success();
    }

    @PostMapping("/ziChainsert")
    @ApiOperation(value = "自查")
    public AjaxResult zicha(@RequestBody List<ACheckQuatzZichaRequest> list) {
        for (ACheckQuatzZichaRequest a : list) {
            /**
             * 自查任务 a_safe_zcrw
             */
            String zcrwUuid = UUID.randomUUID().toString().replace("-", "").toLowerCase();
            String zcrwjlUuid = UUID.randomUUID().toString().replace("-", "").toLowerCase();
            ASafeZcrw aSafeZcrw = new ASafeZcrw();
            aSafeZcrw.setXxbh(zcrwUuid);
            //企业编号
            aSafeZcrw.setQybh(a.getEnterpriseID());
            //自查项
            aSafeZcrw.setZcx(list.size());
            //完成项
            aSafeZcrw.setWcx(list.size());
            //发现隐患数
            aSafeZcrw.setFxyhs(list.size());
            //完成状态
            aSafeZcrw.setWczt(1);
            //入库时间
            aSafeZcrw.setRksj(new Date());
            //更新时间
            aSafeZcrw.setGxsj(new Date());
            aSafeZcrwService.save(aSafeZcrw);
            /**
             * 自查任务检查项记录 a_safe_zcrwjl
             */
            ASafeZcrwjl aSafeZcrwjl = new ASafeZcrwjl();
            aSafeZcrwjl.setXxbh(zcrwjlUuid);
            //企业编号
            aSafeZcrwjl.setQybh(a.getEnterpriseID());
            //任务编号
            aSafeZcrwjl.setRwbh(zcrwUuid);
            //企业风险点编号
            aSafeZcrwjl.setQyfxdbh(a.getCheckId());
            //入库时间
            aSafeZcrwjl.setRksj(new Date());
            //更新时间
            aSafeZcrwjl.setGxsj(new Date());
            aSafeZcrwjlService.save(aSafeZcrwjl);
            /**
             *自查任务位置表a_safe_zcrwwz
             */
            // 少表 todo


        }
        return success();
    }
}
